local AirbossStennis = AIRBOSS:New("CVN-72")

local playerZoneVisits = {}
local globalCallsignAssignments = {}


local atisZones = {
    ["Kutaisi"] = {frequency = 270.50, airbaseName = AIRBASE.Caucasus.Kutaisi, runways = {"07", "25"}},
    ["Maykop"] = {frequency = 270.10, airbaseName = AIRBASE.Caucasus.Maykop_Khanskaya, runways = {"04", "22"}},
    ["Red Carrier"] = {frequency = 305.50, airbaseName = "CVN-72", runways = {"N/A"}},
    ["Blue Carrier"] = {frequency = 305.50, airbaseName = "CVN-73", runways = {"N/A"}},
    ["Anapa"] = {frequency = 270.30, airbaseName = AIRBASE.Caucasus.Anapa_Vityazevo, runways = {"04", "22"}},
    ["Mozdok"] = {frequency = 270.60, airbaseName = AIRBASE.Caucasus.Mozdok, runways = {"08", "26"}},
    ["Sochi"] = {frequency = 270.40, airbaseName = AIRBASE.Caucasus.Sochi_Adler, runways = {"06", "24"}},
    ["Senaki"] = {frequency = 270.24, airbaseName = AIRBASE.Caucasus.Senaki_Kolkhi, runways = {"27", "09"}},
	["Kobuleti"] = {frequency = 270.23, airbaseName = AIRBASE.Caucasus.Kobuleti, runways = {"25", "07"}},
	["Mineralnye"] = {frequency = 270.20, airbaseName = AIRBASE.Caucasus.Mineralnye_Vody, runways = {"12", "30"}},
	["Sukhumi"] = {frequency = 270.25, airbaseName = AIRBASE.Caucasus.Sukhumi_Babushara, runways = {"12", "30"}},
	["Gudauta"] = {frequency = 270.15, airbaseName = AIRBASE.Caucasus.Gudauta, runways = {"15", "33"}},
	["Krymsk"] = {frequency = 270.15, airbaseName = AIRBASE.Caucasus.Krymsk, runways = {"04", "22"}},
	["Batumi"] = {frequency = 270.15, airbaseName = AIRBASE.Caucasus.Batumi, runways = {"31", "13"}}
}

local atisZoneNames = {
    ["Sochi-Adler"] = {frequency = 270.15, airbaseName = AIRBASE.Caucasus.Sochi_Adler, runways = {"04", "22"}},
    ["Maykop-Khanskaya"] = {frequency = 270.10, airbaseName = AIRBASE.Caucasus.Maykop_Khanskaya, runways = {"04", "22"}},
    ["Anapa-Vityazevo"] = {frequency = 270.30, airbaseName = AIRBASE.Caucasus.Anapa_Vityazevo, runways = {"04", "22"}},
    ["Senaki-Kolkhi"] = {frequency = 270.24, airbaseName = AIRBASE.Caucasus.Senaki_Kolkhi, runways = {"27", "09"}},
	["Mineralnye Vody"] = {frequency = 270.20, airbaseName = AIRBASE.Caucasus.Mineralnye_Vody, runways = {"12", "30"}},
	["Sukhumi-Babushara"] = {frequency = 270.25, airbaseName = AIRBASE.Caucasus.Sukhumi_Babushara, runways = {"12", "30"}},
}

-- Define all zones
local allZones = {
    "Kutaisi", "Maykop", "Red Carrier", "Blue Carrier", "Anapa", "Mozdok", "Sochi", "Mineralnye",
    "Batumi", "Kobuleti", "Senaki", "Sukhumi", "Gudauta", "Gelendzhik", "Novorossiysk", "Krymsk",
    "Krasnodar-Center", "Krasnodar-Pashkovsky", "Nalchik", "Beslan", "Soganlug", "Tbilisi", "Vaziani",
    "Alpha", "Bravo", "Charlie", "Delta", "Echo", "Foxtrot", "Golf", "Hotel", "India", "Juliett",
    "Kilo", "Lima"
}
airbaseStatics = {
	["Alpha"] = {"Farpalphaammo", "Farpalphafuel", "Farpalphatent1", "Farpalphatent2", "Farpalphatent3", "Farpalphatent4", "Farpalphacommand", "Farpalphawind"},
    ["Bravo"] = {"Farbravoammo", "Farpbravofuel", "Farpbravotent1", "Farpbravotent2", "Farpbravotent3", "Farpbravotent4", "Farpbravocommand", "Farpbravowind"},
    ["Charlie"] = {"Farpcharliammo", "Farpcharliefuel", "Farpcharlietent1", "Farpcharlietent2", "Farpcharlietent3", "Farpcharlietent4", "Farpcharlicenter", "Farpcharliewind"},
    ["Delta"] = {"Farpdeltaammo", "Farpdeltafuel", "Farpdeltatent1", "Farpdeltatent2", "Farpdeltatent3", "Farpdeltatent4", "Farpdeltacenter", "Farpdeltawind"},
    ["Echo"] = {"Farpechoammo", "Farpechofuel", "Farpechotent1", "Farpechotent2", "Farpechotent3", "Farpechotent4", "Farpechocommand", "Farpechowind"},
    ["Foxtrot"] = {"Farpfoxtrotammo", "Farpfoxtrotfuel", "Farpfoxtrottent1", "Farpfoxtrottent2", "Farpfoxtrottent3", "Farpfoxtrottent4", "Farpfoxtrotcommand", "Farpfoxtrotwind"},
    ["Golf"] = {"Farpgolfammo", "Farpgolffuel", "Farpgolftent1", "Farpgolftent2", "Farpgolftent3", "Farpgolftent4", "Farpgolfcommand", "Farpgolfwind"},
    ["Hotel"] = {"Farphotelammo", "Farphotelfuel", "Farphoteltent1", "Farphoteltent2", "Farphoteltent3", "Farphoteltent4", "Farphotelcommand", "Farphotelwind"},
    ["India"] = {"Farpindiaammo", "Farpindiafuel", "Farpindiatent1", "Farpindiatent2", "Farpindiatent3", "Farpindiatent4", "Farpindiacommand", "Farpindiawind"},
    ["Juliett"] = {"Farpjuliettammo", "Farpjuliettfuel", "Farpjulietttent1", "Farpjulietttent2", "Farpjulietttent3", "Farpjulietttent4", "Farpjulietttent1command", "Farpjuliettwind"},
    ["Kilo"] = {"Farpkiloammo", "Farpkilofuel", "Farpkilotent1", "Farpkilotent2", "Farpkilotent3", "Farpkilotent4", "Farpkilocommand", "Farpkilowind"},
    ["Lima"] = {"Farplimaammo", "Farplimafuel", "Farplimatent1", "Farplimatent2", "Farplimatent3", "Farplimatent4", "Farplimacommand", "Farplimawind"},
	    
}

staticDetails = {}

function GatherStaticDetails()
    for airbaseName, staticNames in pairs(airbaseStatics) do
        for _, staticName in ipairs(staticNames) do
            local static = STATIC:FindByName(staticName)
            if static and static:IsAlive() then
                local point = static:GetPointVec3()
                local typeName = static:GetTypeName()
                local coalitionSide = static:GetCoalition()
                local heading = static:GetHeading()
                staticDetails[staticName] = {
                    airbaseName = airbaseName,
                    typeName = typeName,
                    coalitionSide = coalitionSide,
                    point = point,
                    heading = heading,
                }
            else
                env.info("Статика не найдена или отсутствует: " .. staticName)
            end
        end
    end
end

function RespawnStaticsForAirbase(airbaseName, coalitionSide)
    local statics = airbaseStatics[airbaseName]
    if not statics then
        return
    end

    local countryID
    if coalitionSide == coalition.side.BLUE then
        countryID = country.id.USA
    elseif coalitionSide == coalition.side.RED then
        countryID = country.id.RUSSIA
    else
        return
    end

    for _, staticName in ipairs(statics) do
        local static = STATIC:FindByName(staticName, false)
        if static and static:IsAlive() then
            static:ReSpawn(countryID)
        else
            local details = staticDetails[staticName]
            if details then
                local headingInRadians = math.rad(details.heading)
                local spawnTemplate = {
                    ["name"] = staticName,
                    ["type"] = details.typeName,
                    ["category"] = "Static",
                    ["country"] = countryID,
                    ["heading"] = headingInRadians,
                    ["position"] = details.point,
                }
                local spawnStatic = SPAWNSTATIC:NewFromTemplate(spawnTemplate, countryID)
                spawnStatic:SpawnFromCoordinate(COORDINATE:NewFromVec3(details.point))
            end
        end
    end
end

GatherStaticDetails()



local aircraftAssignments = {
    ["F.A.18"] = {
        ["Arctic1"] = {
            IFFs = {1400, 1401, 1402, 1403},
            assignments = {}
        },
        ["Bender2"] = {
            IFFs = {1404, 1405, 1406, 1407},
            assignments = {}
        },
        ["Crimson3"] = {
            IFFs = {1410, 1411, 1412, 1413},
            assignments = {}
        },
        ["Dusty4"] = {
            IFFs = {1300, 1301, 1302, 1303},
            assignments = {}
        },
        ["Lion3"] = {
            IFFs = {1310, 1311, 1312, 1313},
            assignments = {}
        },
    },
    ["F.16CM"] = {
        ["Jester1"] = {
            IFFs = {1500, 1501, 1502, 1503},
            assignments = {}
        },
        ["Indy9"] = {
            IFFs = {1510, 1511, 1512, 1513},
            assignments = {}
        },
        ["Venom4"] = {
            IFFs = {1610, 1611, 1612, 1613},
            assignments = {}
        },
    },
    ["A.10C"] = {
        ["Hawg8"] = {
            IFFs = {1330, 1331, 1332, 1333},
            assignments = {}
        },
        ["Tusk2"] = {
            IFFs = {1350, 1351, 1352, 1353},
            assignments = {}
        },
        ["Pig7"] = {
            IFFs = {1340, 1341, 1342, 1343},
            assignments = {}
        },
    },
    ["AH.64D"] = {
        ["Rage9"] = {
            IFFs = {1610, 1611, 1612, 1613},
            assignments = {}
        },
        ["Salty1"] = {
            IFFs = {1620, 1621, 1622, 1623},
            assignments = {}
        },
    },
    ["AJS37"] = {
        ["Fenris6"] = {
            IFFs = {1060, 1061, 1062, 1063},
            assignments = {}
        },
        ["Grim7"] = {
            IFFs = {1070, 1071, 1072, 1073},
            assignments = {}
        },
    },
    ["UH.1H"] = {
        ["Nitro5"] = {
            IFFs = {1050, 1051, 1052, 1053},
            assignments = {}
        },
    },
    ["CH.47F"] = { 
        ["Greyhound3"] = { 
            IFFs = {1370, 1371, 1372, 1373}, 
            assignments = {}
        },
    },
    ["F.15E.S4"] = { 
        ["Hitman3"] = { 
            IFFs = {1360, 1361, 1362, 1363}, 
            assignments = {}
        },
    },
    ["F.14.B"] = { 
        ["Elvis5"] = { 
            IFFs = {1100, 1101, 1102, 1103}, 
            assignments = {}
        },
        ["Mustang4"] = { 
            IFFs = {1104, 1105, 1106, 1107}, 
            assignments = {}
        },
    },
}

local zoneAssignments = {}

function logZoneAssignments()
    BASE:I("Zone Assignments:")
    for zone, assignments in pairs(zoneAssignments) do
        BASE:I("Zone: " .. zone)
        for fullCallsign, assignedPlayer in pairs(assignments) do
            BASE:I("    Callsign: " .. fullCallsign .. " -> Player: " .. assignedPlayer)
        end
    end
end


local function isCallsignUsedInOtherZones(fullCallsign, currentZone)
    for zone, assignments in pairs(zoneAssignments) do
        if assignments[fullCallsign] then
            if zone ~= currentZone then
                return true  -- Callsign is used in another zone, don't reuse
            elseif assignments[fullCallsign] then
                return true  -- Callsign is used in the current zone
            end
        end
    end
    return false
end



function getAssignedCallsignAndIFF(groupName)
    for prefix, typeAssignments in pairs(aircraftAssignments) do
        if string.find(groupName, prefix) then
            for callsign, details in pairs(typeAssignments) do
                for i, IFF in ipairs(details.IFFs) do
                    local fullCallsign = callsign .. "" .. i
                    if not isCallsignUsedInOtherZones(fullCallsign, zoneName) then
                        return fullCallsign, IFF
                    end
                end
            end
        end
    end
    return nil, nil
end

function findOrAssignSlot(playerName, groupName, zoneName)
    -- Ensure there's a tracking table for the current zone
    zoneAssignments[zoneName] = zoneAssignments[zoneName] or {}

    -- Iterate through the aircraftAssignments to find the correct prefix and flight assignment
    for prefix, typeAssignments in pairs(aircraftAssignments) do
        if string.find(groupName, prefix) then
            local preferredOrder
			if prefix == "F.A.18" then
				preferredOrder = {"Arctic1", "Bender2", "Crimson3", "Dusty4", "Lion3"}
			elseif prefix == "F.16CM" then
				preferredOrder = {"Jester1", "Indy9", "Venom4"}
			elseif prefix == "A.10C" then
				preferredOrder = {"Hawg8", "Tusk2", "Pig7"}
			elseif prefix == "AH.64D" then
				preferredOrder = {"Rage9", "Salty1"}
			elseif prefix == "AJS37" then
				preferredOrder = {"Fenris6", "Grim7"}
			elseif prefix == "UH.1H" then
				preferredOrder = {"Nitro5"}
			elseif prefix == "CH.47F" then
				preferredOrder = {"Greyhound3"}
			elseif prefix == "F.15E.S4" then
				preferredOrder = {"Hitman3"}
			elseif prefix == "F.14.B" then
				preferredOrder = {"Elvis5", "Mustang4"}
			end

            -- First, check if the main callsigns are used in the **current zone**
            local availableMainCallsign = nil
            local existingPrefixInZone = nil

            -- Check for existing call signs within the current zone
            for _, mainCallsign in ipairs(preferredOrder) do
                for i = 1, #typeAssignments[mainCallsign].IFFs do
                    local fullCallsign = mainCallsign .. "" .. i
                    if zoneAssignments[zoneName][fullCallsign] then
                        -- If there is already an Arctic1 or similar in the current zone, use this prefix
                        existingPrefixInZone = mainCallsign
                        break
                    end
                end
                if existingPrefixInZone then
                    break
                end
            end

            -- If no Arctic1 (or similar) is in the current zone, check if Arctic1 is in **other zones**
            if not existingPrefixInZone then
                for _, mainCallsign in ipairs(preferredOrder) do
                    local isUsedInOtherZones = false
                    for zone, assignments in pairs(zoneAssignments) do
                        if zone ~= zoneName then  -- We are only interested in checking other zones
                            for fullCallsign, assignedPlayer in pairs(assignments) do
                                if string.find(fullCallsign, mainCallsign) then
                                    isUsedInOtherZones = true
                                    break
                                end
                            end
                        end
                    end
                    -- If the main callsign is **not used in other zones**, assign it to the current zone
                    if not isUsedInOtherZones then
                        availableMainCallsign = mainCallsign
                        break
                    end
                end
            else
                availableMainCallsign = existingPrefixInZone  -- Continue with the same flight prefix in this zone
            end

            -- Now assign a specific slot within the available main callsign
            if availableMainCallsign then
                for i, IFF in ipairs(typeAssignments[availableMainCallsign].IFFs) do
                    local fullCallsign = availableMainCallsign .. "" .. i
                    if not zoneAssignments[zoneName][fullCallsign] then
                        -- Update zoneAssignments
                        zoneAssignments[zoneName][fullCallsign] = playerName

                        -- Update globalCallsignAssignments
                        globalCallsignAssignments[playerName] = {callsign = fullCallsign, zoneName = zoneName}

                        BASE:I(string.format("Назначение %s пилоту %s в зоне %s", fullCallsign, playerName, zoneName))
                        logZoneAssignments()  -- Вести журнал текущего состояния ZoneAssignments
                        return fullCallsign, IFF
                    end
                end
            end

            -- If we cannot assign from the main callsign, check if the first callsign is available before cycling back
            for _, mainCallsign in ipairs(preferredOrder) do
                for i, IFF in ipairs(typeAssignments[mainCallsign].IFFs) do
                    local fullCallsign = mainCallsign .. "" .. i
                    if not isCallsignUsedInOtherZones(fullCallsign, zoneName) and zoneAssignments[zoneName][fullCallsign] == nil then
                        -- Update zoneAssignments
                        zoneAssignments[zoneName][fullCallsign] = playerName

                        -- Update globalCallsignAssignments
                        globalCallsignAssignments[playerName] = {callsign = fullCallsign, zoneName = zoneName}

                        BASE:I(string.format("Назначение %s пилоту %s в зоне %s (cycled back, first available)", fullCallsign, playerName, zoneName))
                        logZoneAssignments()  -- Log the current state of zoneAssignments
                        return fullCallsign, IFF
                    end
                end
            end

            -- Fallback logic: Assign the first available slot in the current zone
            for _, mainCallsign in ipairs(preferredOrder) do
                for i, IFF in ipairs(typeAssignments[mainCallsign].IFFs) do
                    local fullCallsign = mainCallsign .. "" .. i
                    if not zoneAssignments[zoneName][fullCallsign] then
                        -- Update zoneAssignments
                        zoneAssignments[zoneName][fullCallsign] = playerName

                        -- Update globalCallsignAssignments
                        globalCallsignAssignments[playerName] = {callsign = fullCallsign, zoneName = zoneName}

                        BASE:I(string.format("Назначение %s пилоту %s в зоне %s (cycled back, fallback)", fullCallsign, playerName, zoneName))
                        logZoneAssignments()  -- Log the current state of zoneAssignments
                        return fullCallsign, IFF
                    end
                end
            end
        end
    end

    -- If no assignment could be made, return nil values
    return nil, nil
end


function releaseSlot(playerName, zoneName)
    -- Check if the player has an assigned callsign in the specified zone
    if zoneAssignments[zoneName] then
        for callsign, assignedPlayer in pairs(zoneAssignments[zoneName]) do
            if assignedPlayer == playerName then
                -- Release the callsign
                zoneAssignments[zoneName][callsign] = nil

                -- Also remove the global assignment
                globalCallsignAssignments[playerName] = nil

                BASE:I(string.format("Выпущено %s от игрока %s в зоне %s", callsign, playerName, zoneName))
                break
            end
        end
    end
end


function sendGreetingToPlayer(playerUnitID, greetingMessage)
    trigger.action.outTextForUnit(playerUnitID, greetingMessage, 55)
end



function sendDetailedMessageToPlayer(args)
    local playerUnitID = args[1]
    local message = args[2]
    local playerGroupID = args[3]
    trigger.action.outTextForUnit(playerUnitID, message, 120)
    if trigger.misc.getUserFlag(180) == 0 then
        trigger.action.outSoundForGroup(playerGroupID, "admin.wav")
    end
end

local function getAltimeter()
    local coord = COORDINATE:NewFromVec3({x = 0, y = 0, z = 0})
    local pressure_hPa = coord:GetPressure(0)  
    local pressureInHg = pressure_hPa * 0.0295300
    return string.format("Давление %.2f", pressureInHg)
end


local function getBRC()
    if AirbossStennis then
        local brc = AirbossStennis:GetBRC()
        return string.format("Взлетный %d°", brc)
    else
        return "Данные курс взлет недоступны"
    end
end


local function getAirbaseWind(airbaseName)
    local airbase = AIRBASE:FindByName(airbaseName)
    if airbase then
        local airbaseCoord = airbase:GetCoordinate()  
        local windDirection, windSpeed = airbaseCoord:GetWind(0)
        if windDirection and windSpeed then
            local windSpeedKnots = math.floor(windSpeed * 1.94384)
            windDirection = (windDirection + 360) % 360
            return string.format("Курс ветера %03d° скорость %d", windDirection, windSpeedKnots), windDirection
        else
            return "Данные о ветре отсутствуют", nil
        end
    else
        return "Авиабаза не найдена", nil
    end
end


local function calculateFallbackRunway(zoneName)
    local zoneInfo = atisZones[zoneName]
    if not zoneInfo or not zoneInfo.runways then
        trigger.action.outText("Данные о ВПП для района отсутствуют: " .. zoneName, 10)
        return "Данные об активной ВПП недоступны."
    end
    
    
    local _, windDirection = getAirbaseWind(zoneInfo.airbaseName)
    if windDirection == nil then
        return "Данные о направлении ветра отсутствуют."
    end

    local bestRunway = nil
    local smallestDelta = 360

   
    for _, runway in ipairs(zoneInfo.runways) do
        local runwayHeading = tonumber(runway:sub(1, 2)) * 10
        local delta = math.abs(runwayHeading - windDirection)
        if delta > 180 then 
            delta = 360 - delta
        end
        if delta < smallestDelta then
            smallestDelta = delta
            bestRunway = runway
        end
    end

    if bestRunway then
        return string.format("В работе ВПП: %s", bestRunway)
    else
        return "Не найдено подходящей ВПП с учетом ветра."
    end
end


local function fetchActiveRunway(zoneName)
    local airbase = AIRBASE:FindByName(atisZones[zoneName].airbaseName)
    if not airbase then
        trigger.action.outText("Обнаружен конфликт авиабаз/ФАРП или авиабаза не найдена: " .. atisZones[zoneName].airbaseName, 10)
        return "Данные по авиабазам недоступны."
    end

    local windMessage, windDirection = getAirbaseWind(atisZones[zoneName].airbaseName)
    if windDirection == nil then
        return "Данные о направлении ветра отсутствуют."
    end

    local activeRunway = airbase:GetRunwayIntoWind()
    if activeRunway then
        local runwayName = airbase:GetRunwayName(activeRunway)
        if runwayName and runwayName ~= "" then
            
            return string.format("В работе ВПП: %s", runwayName)
        end
    end

    
    return calculateFallbackRunway(zoneName, windDirection)
end

local function getCarrierWind()
    local cvn = UNIT:FindByName("CVN-72")
    if cvn then
        local cvnCoord = cvn:GetCoordinate()
        local windDirection, windSpeed = cvnCoord:GetWind(0)
        if windDirection and windSpeed then
            local windSpeedKnots = windSpeed * 1.94384  
            windDirection = (windDirection + 360) % 360
            return string.format("Курс ветера %03d° скорость %d",windDirection, windSpeedKnots)
        else
            return "Данные о ветре отсутствуют"
        end
    else
        return "Авианосец не найден"
    end
end


local function getPlayerWind(playerCoord)
    local playerPosition = playerCoord:GetVec3()
    local windVector = atmosphere.getWind(playerPosition)
    if windVector then
        local windSpeedMps = math.sqrt(windVector.x^2 + windVector.z^2)
        local windSpeedKnots = math.floor(windSpeedMps * 1.94384)
        local originalWindDirection = math.deg(math.atan2(windVector.z, windVector.x))
        originalWindDirection = (originalWindDirection + 360) % 360
        local originatingWindDirection = (originalWindDirection + 180) % 360
        return string.format("Курс ветера %03d° скорость %d", originatingWindDirection, windSpeedKnots), originatingWindDirection
    else
        return "Данные о ветре отсутствуют", nil
    end
end

local function getPlayerTemperature(playerCoord)
    local playerPosition = playerCoord:GetVec3()
    local temperatureCelsius = playerCoord:GetTemperature(playerPosition.y)  -- Getting temperature at the player's altitude (ASL)
    
    if temperatureCelsius then
        return string.format("Температура %d°C", temperatureCelsius)
    else
        return "Данные о температуре недоступны"
    end
end

local function getPlayerWeatherReport(playerCoord)
    local windMessage, windDirection = getPlayerWind(playerCoord)
    local temperatureMessage = getPlayerTemperature(playerCoord)

    -- Combine wind and temperature messages into a single weather report
    local weatherReport = string.format("%s\n%s", windMessage, temperatureMessage)

    return weatherReport
end

-- ATIS MENU --

local function sendATISInformation(client, group, zoneName)
    local messageText
    
    if string.find(zoneName, "Carrier") then
        local windMessage = getCarrierWind()
        local brcMessage = getBRC()  
        local altimeterMessage = getAltimeter()
        messageText = string.format("АТИС:\n\n%s, %s\n\n%s", windMessage, altimeterMessage, brcMessage or "Данные курс взлет недоступны")
        MESSAGE:New(messageText, 15, ""):ToUnit(client)
    else
        
        local windMessage, windDirection = getAirbaseWind(atisZones[zoneName].airbaseName)
        if windMessage == "Данные о ветре отсутствуют" or windMessage == "Авиабаза не найдена" then
            messageText = string.format("ATIS для %s:\n\n%s", zoneName, windMessage)
        else
            local runwayInfo = fetchActiveRunway(zoneName, windDirection)
            messageText = string.format("ATIS для %s:\n\n%s, %s\n\n%s.", zoneName, windMessage, getAltimeter(), runwayInfo or "Информация о ВПП недоступна")
        end
        MESSAGE:New(messageText, 20, ""):ToUnit(client)
    end
end


local MainMenu = {}
local static = STATIC:FindByName("EventMan", true)


function SetupATISMenu(client)
    local group = client:GetGroup()
    if not group then
        
        return
    end

    local groupID = group:GetName()

   
    if MainMenu[groupID] then
        MainMenu[groupID]:Remove()
    end

    
    local mainMenu = MENU_GROUP:New(group, "Информация ATIS")
    MainMenu[groupID] = mainMenu

    local currentMenu = mainMenu
    local menuItemCount = 1

   
    MENU_GROUP_COMMAND:New(group, "Получить ATIS для корабля", mainMenu, sendATISInformation, client, group, "Carrier")

 
    for zoneName, details in pairs(atisZones) do
        if not zoneName:find("Carrier") then
            local airbase = AIRBASE:FindByName(details.airbaseName)
            if airbase and airbase:GetCoalitionName() == 'Blue' then
                if menuItemCount >= 9 then
                    currentMenu = MENU_GROUP:New(group, "Следующая страница...", mainMenu)
                    menuItemCount = 0
                end
                MENU_GROUP_COMMAND:New(group, "Получите ATIS для " .. zoneName, currentMenu, sendATISInformation, client, group, zoneName)
                menuItemCount = menuItemCount + 1
            end
        end
    end
end


local lastMessageTime = {}


function static:onBaseCapture(_event)
local event = _event -- Core.Event#EVENTDATA
if event.id == EVENTS.BaseCaptured and event.Place then
	local capturedBaseName = event.Place:GetName()  
	local coalitionSide = event.Place:GetCoalition()
	
	--RespawnStaticsForAirbase(capturedBaseName, coalitionSide)
	if (atisZoneNames[capturedBaseName] or atisZones[capturedBaseName]) and event.Place:GetCoalition() == coalition.side.BLUE then  
	
			
			local clientSet = SET_CLIENT:New():FilterCategories("plane"):FilterCoalitions("blue"):FilterAlive():FilterOnce()
			clientSet:ForEachClient(function(client)
				SetupATISMenu(client)  
				
				local messageText = string.format("ATIS для %s теперь доступен.", capturedBaseName)
				MESSAGE:New(messageText, 20, ""):ToClient(client)
			end)
		end
	end  
end

function static:onPlayerSpawn(_event)
local event = _event
if event.id == EVENTS.PlayerEnterAircraft and event.IniUnit and event.IniPlayerName then
	local player = event.IniUnit
	local playerName = player:GetPlayerName()
	
	if player:GetUnitCategory() == Unit.Category.AIRPLANE then
		SetupATISMenu(player)
	end
	
	local group = player:GetGroup()
	local groupName = group:GetName()
	
	-- Iterate through all zones
	for _, zoneName in ipairs(allZones) do
		local zone = ZONE:New(zoneName)
		if zone and zone:IsCoordinateInZone(player:GetCoordinate()) then
			local playerUnitID = player:GetID()
			local playerGroupID = player:GetGroup():GetID()
			
			-- Check if this is a new visit for the player
			local isNewVisit = not playerZoneVisits[playerName] or not playerZoneVisits[playerName][zoneName]
			playerZoneVisits[playerName] = playerZoneVisits[playerName] or {}
			playerZoneVisits[playerName][zoneName] = true

			-- Find or assign the callsign and IFF for the player
			local assignedCallsign, assignedIFF = findOrAssignSlot(playerName, groupName, zoneName)

			-- Prepare messages
			local altimeterMessage = getAltimeter()
			local temperatureMessage = getPlayerTemperature(player:GetCoordinate())
			local greetingMessage, detailedMessage
			
			-- If the player is near a carrier
			if string.find(zoneName, "Carrier") then
				local brcMessage = getBRC()
				local carrierWindMessage = getCarrierWind()

				if assignedCallsign and assignedIFF then
					greetingMessage = string.format("Добро пожаловать на борт Авраама Линкольна, %s!\n\nВаш позывной %s, IFF %d.\n\nЖдем прогноза погоды с Центра.", playerName, assignedCallsign, assignedIFF)
					detailedMessage = string.format("Добро пожаловать на борт Авраама Линкольна, %s!\n\n%s, %s, %s\n\n%s\n\nНа удалении 7 миль переключитесь на канал CH 3.", assignedCallsign, carrierWindMessage, temperatureMessage, altimeterMessage, brcMessage)
				else
					greetingMessage = string.format("Добро пожаловать на борт Авраама Линкольна, %s!\n\nОпределяем погоду и курс взлет.", playerName)
					detailedMessage = string.format("Добро пожаловать на борт Авраама Линкольна, %s!\n\n%s, %s, %s\n\n%s\n\nНа удалении 7 миль переключитесь на канал CH 3.", playerName, carrierWindMessage, temperatureMessage, altimeterMessage, brcMessage)
				end

			else
				-- If the player is at an airbase
				local windMessage, displayWindDirection

				if atisZones[zoneName] then
					windMessage, displayWindDirection = getAirbaseWind(atisZones[zoneName].airbaseName)
					local activeRunwayMessage = fetchActiveRunway(zoneName, displayWindDirection)

					if isNewVisit then
						if assignedCallsign and assignedIFF then
							greetingMessage = string.format("Добро пожаловать в %s, %s!\n\nВаш позывной %s, IFF %d.\n\nОпределяем погоду и ATIS.", zoneName, playerName, assignedCallsign, assignedIFF)
							detailedMessage = string.format("Добро пожаловать в %s, %s!\n\n%s, %s, %s.\n\n%s.\n\nВзлетев, переключитесь на канал CH 3.", zoneName, assignedCallsign, windMessage, temperatureMessage, altimeterMessage, activeRunwayMessage)
						else
							greetingMessage = string.format("Добро пожаловать в %s, %s!\n\nСобираю информацию о погоде.", zoneName, playerName)
							detailedMessage = string.format("Добро пожаловать в %s, %s!\n\n%s, %s, %s.\n\n%s.\n\nВзлетев, переключитесь на канал CH 3.", zoneName, playerName, windMessage, temperatureMessage, altimeterMessage, activeRunwayMessage)
						end

					else
						if assignedCallsign and assignedIFF then
							greetingMessage = string.format("Добро пожаловать в %s, %s!\n\nВаш позывной %s, IFF %d.\n\nЖдем информацию о погоде и ATIS.", zoneName, playerName, assignedCallsign, assignedIFF)
							detailedMessage = string.format("Добро пожаловать в %s, %s!\n\n%s, %s, %s.\n\n%s.\n\nВзлетев, переключитесь на канал CH 3.", zoneName, assignedCallsign, windMessage, temperatureMessage, altimeterMessage, activeRunwayMessage)
						else
							greetingMessage = string.format("Добро пожаловать в %s, %s!\n\nБудьте готовы к обновлению погоды.", zoneName, playerName)
							detailedMessage = string.format("Добро пожаловать в %s, %s!\n\n%s, %s, %s.\n\n%s.\n\nВзлетев, переключитесь на канал CH 3.", zoneName, playerName, windMessage, temperatureMessage, altimeterMessage, activeRunwayMessage)
						end
					end
				else
					-- Handle other locations not defined as specific airbases
					local playerCoord = player:GetCoordinate()
					windMessage, _ = getPlayerWind(playerCoord)
					temperatureMessage = getPlayerTemperature(playerCoord)

					if isNewVisit then
						if assignedCallsign and assignedIFF then
							greetingMessage = string.format("Добро пожаловать в %s, %s!\n\nВаш позывной %s, IFF %d.\n\nСобираю информацию о погоде.", zoneName, playerName, assignedCallsign, assignedIFF)
							detailedMessage = string.format("Добро пожаловать в %s, %s!\n\n%s, %s, %s.\n\nВзлетев, переключитесь на канал CH 3.\n\nНе забудьте БК", zoneName, assignedCallsign, windMessage, temperatureMessage, altimeterMessage)
						else
							greetingMessage = string.format("Добро пожаловать в %s, %s!\n\nСобираю информацию о погоде.", zoneName, playerName)
							detailedMessage = string.format("Добро пожаловать в %s, %s!\n\n%s, %s, %s.\n\nВзлетев, переключитесь на канал CH 3.\n\nНе забудьте БК", zoneName, playerName, windMessage, temperatureMessage, altimeterMessage)
						end

					else
						if assignedCallsign and assignedIFF then
							greetingMessage = string.format("Добро пожаловать в %s, %s!\n\nВаш позывной %s, IFF %d.\n\nСобираю информацию о погоде.", zoneName, playerName, assignedCallsign, assignedIFF)
							detailedMessage = string.format("Добро пожаловать в %s, %s!\n\n%s, %s, %s.\n\nВзлетев, переключитесь на канал CH 3.\n\nНе забудьте БК", zoneName, assignedCallsign, windMessage, temperatureMessage, altimeterMessage)
						else
							greetingMessage = string.format("Добро пожаловать в %s, %s!\n\nБудьте готовы к обновлению погоды.", zoneName, playerName)
							detailedMessage = string.format("Добро пожаловать в %s, %s!\n\n%s, %s, %s.\n\nВзлетев, переключитесь на канал CH 3.\n\nНе забудьте БК", zoneName, playerName, windMessage, temperatureMessage, altimeterMessage)
						end
					end
				end
			end
				sendGreetingToPlayer(playerUnitID, greetingMessage)
				timer.scheduleFunction(sendDetailedMessageToPlayer, {playerUnitID, detailedMessage, playerGroupID}, timer.getTime() + 60)

			end
		end
	end
end


function static:onPlayerLeaveUnit(_event)
    BASE:I("onPlayerLeaveUnit called")

    local event = _event

    if event.id == EVENTS.PlayerLeaveUnit or event.id == EVENTS.PilotDead then
        if event.IniPlayerName then
            local playerName = event.IniPlayerName
            BASE:I("Player leaving unit: " .. playerName)

            if globalCallsignAssignments[playerName] then
                local callsignInfo = globalCallsignAssignments[playerName]
                local zoneName = callsignInfo.zoneName
                BASE:I("Player had assignment: " .. callsignInfo.callsign .. " in zone " .. zoneName)

                releaseSlot(playerName, zoneName)
                globalCallsignAssignments[playerName] = nil
            else
                BASE:I("No global assignment found for player: " .. playerName)
            end
        else
            BASE:I("IniPlayerName is nil. Player might have disconnected without a proper event.")

            local clientSet = SET_CLIENT:New():FilterCategories("plane"):FilterCoalitions("blue"):FilterAlive():FilterOnce()

            for playerName, callsignInfo in pairs(globalCallsignAssignments) do
                local isPlayerAlive = false

                clientSet:ForEachClient(function(client)
                    if client:GetPlayerName() == playerName then
                        isPlayerAlive = true
                    end
                end)

                if not isPlayerAlive then
                    local zoneName = callsignInfo.zoneName
                    BASE:I("Removing dead or disconnected player: " .. playerName .. " from zone " .. zoneName)
                    releaseSlot(playerName, zoneName)
                    globalCallsignAssignments[playerName] = nil
                end
            end
        end
    else
        BASE:I("Event ID does not match PlayerLeaveUnit or PilotDead")
    end
end



static:HandleEvent(EVENTS.PlayerEnterAircraft, static.onPlayerSpawn)
static:HandleEvent(EVENTS.BaseCaptured, static.onBaseCapture)
static:HandleEvent(EVENTS.PlayerLeaveUnit, static.onPlayerLeaveUnit)


local handler = EVENTHANDLER:New()
handler:HandleEvent(EVENTS.Shot)

local function WeaponImpact(Weapon)
  local impactPos = Weapon:GetImpactVec3()
  if impactPos then
    trigger.action.explosion(impactPos, 75)
  end
end

local function WeaponTrack(Weapon)
  local target = Weapon:GetTarget()
  if target and target:GetCategory() == Unit.Category.HELICOPTER and target:GetCoalition() == coalition.side.RED then
  end
end

function handler:OnEventShot(EventData)
  local eventdata = EventData
  if eventdata and eventdata.weapon then
    local weapon = WEAPON:New(eventdata.weapon)
    if weapon:IsMissile() then
      weapon:SetFuncTrack(WeaponTrack)
      weapon:SetFuncImpact(WeaponImpact)
      weapon:StartTrack()
    end
  end
end


BASE:I("Welcome message script and Static manager loading completed")